"""
Requires module.
"""


class Requires(object):
    """
    Requires directive is used for linking dependencies.
    """

    def __init__(self, key, with_name=None, from_namespace=None,
                 provider=None):
        """
        Constructor.

        :param str key:
        :return:
        """
        self.key = key
        self.from_namespace = from_namespace
        if not with_name:
            with_name = key
        self.with_name = with_name
        self.provider = provider

    def provide(self):
        """
        Provides requirement using injected provider.
        """
        return self.provider()


class RequiresProvider(Requires):
    """
    Provider requires directive is used for providing provider.
    """

    def provide(self):
        """
        Provides requirement using injected provider.
        """
        return self.provider
